function [y dy da db ds]=f_bitanh(x,a,b,slope)
% Y=F_BITANH(X) returns value of window function created by multiplication 
%      of tanh functions.
%     
% Y=F_BICENTRAL(X,A,B,S) return value of bitanh function where:
%    A,b interval boundaries (default A=-1,B=1)
%    S slope of function (default S=1)
%
% [Y DY]=F_BITANH(X,A,T,S)  returns value of gradient df/dx

if nargin < 4
    slope=1;
end;
if nargin < 3
	b = 1;
end
if nargin < 2
   a = -1;
end

fxa  = tanh(slope*(x-b));
fxb = tanh(slope*(x-a));

y=-0.5.*(fxa.*fxb+1)+1;

% if nargout > 1
%     da = -(dfxa.*(1-fxb));
%     db = (fxa.*dfxb);
%     dy = -slope*(da + db);
% end
% if nargout > 2
%     da = slope * da;
%     db = slope * db;
% end
% if nargin > 4
%     ds = -da.*(x-a) + db.*(x-b); 
% end