function window_functions

n=50;
min=-5;
max=5;
h=(max-min)./n;

x1=min:h:max;
beta=[0.3 0.5 1 2  10];

a=ones(size(beta));
x=ones(size(beta))'*x1;

y=zeros(size(x));
%y=f_bicentral(x);


% bicentral 2D

a=-2;
b=2;

name='figure-function-bicentral-2d-s5';
figure(1);
set(gcf,'Name',name);
clf;
i=1;
lstr={};

[x2 y2]=meshgrid(x1,x1);

bi=5;
y4=zeros(size(x1));
n=size(x1,2);

for i=1:n
    y4(i,:)=f_bicentral2(x1,a,b,bi).*f_bicentral2(x1(i),a,b,bi);
end




%lstr{i}=sprintf('\\beta=%g',bi);

surf(x2,y2,y4);
data=[x2(:) y2(:) y4(:)];
dlmwrite(strcat(name,'.dat'),data, 'delimiter', '\t', 'precision', 6);

grid on;
box off;

zapisz(name);


name='figure-function-bicentral-2d-s1';
figure(2);
set(gcf,'Name',name);
clf;


bi=1;
for i=1:n
    y5(i,:)=f_bicentral2(x1,a,b,bi).*f_bicentral2(x1(i),a,b,bi);
end

surf(x2,y2,y5);
data=[x2(:) y2(:) y5(:)];
dlmwrite(strcat(name,'.dat'),data, 'delimiter', '\t', 'precision', 6);

grid on;
box off;

zapisz(name);

return;

n=100;
min=-8;
max=8;
h=(max-min)./n;

a=-2;
b=2;

% bicentral 
name='figure-f_bicentral';
figure(1);
set(gcf,'Name',name);
clf;
i=1;
lstr={};
for bi=beta
    y(i,:)=f_bicentral2(x(i,:),a,b,bi);
    lstr{i}=sprintf('\\beta=%g',bi);
    i=i+1;
end

data=[x1' y'];
dlmwrite('figure-function-bicentral.dat',data, 'delimiter', '\t', 'precision', 6);


plot(x',y');
hold on;
grid on;
box off;

legend(lstr);
zapisz(name);

% dwie sigmoidy
name='figure-f_bisigm';
figure(2);
set(gcf,'Name',name);

clf;
i=1;
for bi=beta
    y(i,:)=f_bisigm(x(i,:),a,b,bi);
    i=i+1;
end

data=[x1' y'];
dlmwrite('figure-function-bisigm.dat',data, 'delimiter', '\t', 'precision', 6);


plot(x',y');
hold on;
grid on;
box off;


legend(lstr);
zapisz(name)

name='figure-f_bitanh';
figure(3);
set(gcf,'Name',name);

clf;
i=1;
for bi=beta
    y(i,:)=f_bitangh(x(i,:),a,b,bi);
    i=i+1;
end
data=[x1' y'];
dlmwrite('figure-function-bitangh.dat',data, 'delimiter', '\t', 'precision', 6);

plot(x',y');
hold on;
grid on;
box off;

legend(lstr);
zapisz(name)


function zapisz(name)
% set(gcf,'position',[100 0 600 600],'paperpositionmode','auto',...
%         'color','none','InvertHardcopy','off');
print('-depsc',strcat(name,'.eps'));


