function nb=qpc_nb_train(x,y,dim,method,useglobal)
% QPC + NaiveBayes
% Na potrzeby testow na ICANN 2010 (runtest_icann2010_qpc_nb.m)

if nargin < 5 ; useglobal = 0; end  % use global varaible QPCW (QPCQUICKW)
if nargin < 4; method = 'qpc'; end
if nargin < 3; dim = 1; end
    
%tic;
global qpcw;
if useglobal == 0

    if strcmp(method,'qpc')
        disp('Licze qpc');
         init = 10;
         lr = 0.1;
         [w qpc]=qpctrain(x,y,'OptMethod','gd','QPCMethod','qpc','initiations',init,'learningRate',lr,'display','none','directions',dim);
    else
        disp('Licze qpc proto');
        repetitions = 5;
        randominit = 50;
        lr = 0.1;
        plr = 0.1;
        intervals = 20;
        [w qpc]=qpctrain_proto(x,y,'ProtMethod','qpcquick','Repetitions',repetitions,'prototypes',intervals,'initiations',randominit,'plr',plr,'learningRate',lr,'display','none','directions',dim);
        % qpc=qpcfunction(x,y,w);
    end
    qpcw = w;
else
    disp('Korzystam z globalnej');
    w = qpcw(1:dim,:);
    qpc=qpcfunction(x,y,w);
end

nb.object=NaiveBayes.fit(x*w',y,'Distribution','kernel');
%nb.object=NaiveBayes.fit(x*w',y,'Distribution','normal'); % powtorzenie dla gauss
nb.w = w;
%nb.time=toc;
nb.qpc = qpc;
nb.info = sprintf('%s + NaiveBayes on %d dimensions.',method,dim);
