function net=rpm(data)

% proba wkozystania qpc z prototypami QPCproto do klasyfikacji
%przy pomocy mechanizmy RPM.  Wymagany bylby inny sposob generowania
%losowych kierunkow. Ortogonalizacja jest zbyd mocnym ograniczeniam,
%potrzebujemy duzo kierunko, niekoniecznie ortogonalnych.


stop = 0;


intervals=20;
plr=0.1;
directions = 6;

% while i =1:directions
%     [net{i}.w net{i}.prot] =
%     [w aqpc proto param]=qpctrain_proto(x,y,'ProtMethod','qpcquick','prototypes',intervals,'initiations',randominit,'plr',plr,'learningRate',lr,'display','short','directions',1);
%     
%     i = i +1;
% end

qpc_parameters = qpc_config;

bestw = zeros(directions,data.features);
bestqpc = zeros(directions,1);
bestprot = cell(directions,1);

qpclearning = @(x,y,p)qpc_1d(x,y,p);
init = 100;
x1=zeros(data.vectors,directions);

%parameters.initiations = 1;
acc1=zeros(directions,1);

for dirCount = 1:directions

    if dirCount == 1
        P =  [];
        xp = data.x;
    else
        P=eye(data.features)-bestw'*bestw;  % operator projekcji na podprz. otronormalna
        xp=data.x*P;        
    end
    w1=qpctrain(xp,data.y,'prototypes',intervals,'directions',1,'initiations',init,'OptMethod','random','QPCMethod','quick','beta',1);
    [qpc1 p1 sigma1]=qpcfunction_quick(xp,data.classInfo,w1,intervals);
    p2=project_points(p1(:,1:end-1),w1,mean(xp));
    qpc_parameters.prototypes = [p2 p1(:,end)];
    qpc_parameters.beta = sigma1;
    qpc_parameters.initWeights;
    qpc_parameters.initiations = 1;

    [bw bqpc param]=qpclearning(xp,data.y,qpc_parameters);
    
    px=param.prototypes(:,1:end-1);
    
    if dirCount > 1
        bw=bw*P;
        px=px*P;
    end
    
    net{dirCount}.w = bw;
    net{dirCount}.p = [px* bw' p1(:,end)];
    
%    bestproto{dirCount} = [px qpc_parameters.prototypes(:,end)];
    bestw(dirCount,:)=bw; %/norm(bw);
%    bestqpc(dirCount)=bqpc;
%    info{dirCount} = param.info;

    net{dirCount}.acc = rpm_test(data,net);

    disp(net{dirCount}.w);    
    disp(net{dirCount}.acc);
end


function [parameters unmached]=qpctrain_proto_config(varargin)

param = inputParser;
param.KeepUnmatched = true;
% data
% param.addRequired('x',@isnumeric);
% param.addRequired('y',@isnumeric);
param.addOptional('ProtMethod','means',@(x)any(strcmpi(x,{'qpcquick','fixed','balanced','means'})));
param.parse(varargin{:});
parameters = param.Results;
unmatched = param.Unmatched;
unames=fieldnames(unmatched);
clear param;

if nargout  < 2 && size(unames,1) > 0
        error(['Unknown options: ' sprintf(' "%s"',unames{:})]);
end


return;
